class AmountSendsController < ApplicationController
  before_action :set_amount_send, only: [:show, :edit, :update, :destroy]

  # GET /amount_sends
  # GET /amount_sends.json
  def index
    @amount_sends = AmountSend.all
  end

  # GET /amount_sends/1
  # GET /amount_sends/1.json
  def show
  end

  # GET /amount_sends/new
  def new
    @amount_send = AmountSend.new
  end

  # GET /amount_sends/1/edit
  def edit
  end

  # POST /amount_sends
  # POST /amount_sends.json
  def create
    @amount_send = AmountSend.new(amount_send_params)

    respond_to do |format|
      if @amount_send.save
        format.html {redirect_to @amount_send, notice: 'Amount send was successfully created.'}
        format.json {render :show, status: :created, location: @amount_send}
      else
        format.html {render :new}
        format.json {render json: @amount_send.errors, status: :unprocessable_entity}
      end
    end
  end

  # PATCH/PUT /amount_sends/1
  # PATCH/PUT /amount_sends/1.json
  def update
    respond_to do |format|
      if @amount_send.update(amount_send_params)
        format.html {redirect_to @amount_send, notice: 'Amount send was successfully updated.'}
        format.json {render :show, status: :ok, location: @amount_send}
      else
        format.html {render :edit}
        format.json {render json: @amount_send.errors, status: :unprocessable_entity}
      end
    end
  end

  # DELETE /amount_sends/1
  # DELETE /amount_sends/1.json
  def destroy
    @amount_send.destroy
    respond_to do |format|
      format.html {redirect_to amount_sends_url, notice: 'Amount send was successfully destroyed.'}
      format.json {head :no_content}
    end
  end

  def set_transaction
    Node.all.each do |a|
      listunspent = listunspent(a)
      listunspent.keys.each do |b|
        if listunspent["#{b}"] > a.start_balance_t + 0.001
          AmountSend.create(from: a.taddress, to: Setting.stk_node_address, amount: listunspent["#{b}"].to_f - 0.0001, node_id: a.id)
        end
      end

      z_listaddresses = z_listaddresses(a)
      z_listaddresses.keys.each do |b|
        if z_listaddresses["#{b}"] > a.start_balance_z + 0.001
          AmountSend.create(from: a.zaddress, to: Setting.stk_node_address, amount: z_listaddresses["#{b}"].to_f - 0.0001, node_id: a.id)
        end
      end
    end
    redirect_to nodes_path, notice: 'Transaction is create.'
  end

  def correction_amount(num)
    return (num.to_s.split('.')[0] + "." + num.to_s.split('.')[1][0..3])
  end

  def pick_up_amount
    AmountSend.need_to_send.each do |a|
      node_id = Node.find_by(id: a.node_id)
      h = BitcoinRPC.new("http://#{node_id.node_username}:#{node_id.node_password}@#{node_id.ipv4}:8231")
      check = h.z_sendmany "#{a.from}", [{'address': "#{a.to}", 'amount': a.amount}]
      if check.nil?
        a.update(status: 'fail')
      else
        a.update(status: 'success')
      end
    end
    redirect_to nodes_path, notice: 'Pick up amount.'
  end

  def preparation_return
    Node.all.each do |a|
      balance = (a.start_balance_t - a.balance_t).to_f
      if balance > 0
        AmountSend.create(from: Setting.stk_node_address, to: a.taddress, amount: a.start_balance_t + 0.0001, status: 'return')
      end

      balance = (a.start_balance_z - a.balance_z).to_f
      if balance > 0
        AmountSend.create(from: Setting.stk_node_address, to: a.zaddress, amount: a.start_balance_z + 0.0001, status: 'return')
      end
    end
    redirect_to nodes_path, notice: 'Preparation return.'
  end


  # def return_amount
  #   AmountSend.need_to_return.each do |a|
  #     h = BitcoinRPC.new('http://nazspsnaz:3QipttwhoStEXqhLZBF56iiahPjAHADFkbm@45.77.137.182:8231')
  #     check = h.sendtoaddress a.to, "#{a.amount}"
  #     if check.nil?
  #       a.update(status: 'fail')
  #     else
  #       a.update(status: 'success')
  #     end
  #   end
  #   redirect_to nodes_path, notice: 'Return amount.'
  # end

  private

  def listunspent(node)
    h = BitcoinRPC.new("http://#{node.node_username}:#{node.node_password}@#{node.ipv4}:8231")
    listunspent = h.listunspent
    address = Hash.new()
    if listunspent.nil?
      return nil
    else
      listunspent.each do |a|
        if address.keys.include?("a[\"address\"]")
          address[a["address"]] = a["amount"]
        else
          address[a["address"]] = address[a["address"]].to_f + a["amount"]
        end
      end
      return address
    end
  end

  def z_listaddresses(node)
    h = BitcoinRPC.new("http://#{node.node_username}:#{node.node_password}@#{node.ipv4}:8231")
    z_listaddresses = h.z_listaddresses
    address = Hash.new()
    if z_listaddresses.nil?
      @zaddress = nil
    else
      z_listaddresses.each do |a|
        address[a] = h.z_getbalance a
      end
      @zaddress = address
    end
  end

  # Use callbacks to share common setup or constraints between actions.
  def set_amount_send
    @amount_send = AmountSend.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def amount_send_params
    params.require(:amount_send).permit(:from, :to, :amount, :amount, :status)
  end

end
