class ImagesController < ApplicationController
  before_action :set_image
  layout false

  def show
    render_image
  end

  def edit
  end

  def update
    if @image.update image_params
      render_image
    else
      render nothing: true, status: :internal_server_error
    end
  end

  private
  def render_image
    render html: "<img src='#{@image.data_url}'/>".html_safe, status: :ok
  end

  # Use callbacks to share common setup or constraints between actions.
  def set_image
    @image = Image.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def image_params
    params[:image] = {remove_data: true} if params[:image].nil?
    params.require(:image).permit(:data, :remove_data)
  end

end
