class NodesController < AdminController
  before_action :set_node, only: [:show, :edit, :update, :destroy]

  # GET /nodes
  # GET /nodes.json
  def index
    @nodes = Node.all
    @nodelist = AmountSend.need_to_return.map do |u|
      { :address => u.to, :amount => u.amount}
    end
    @command = "z_sendmany "  + "#{Setting.stk_node_address} " + "'#{@nodelist.to_json}'"
  end

  # GET /nodes/1
  # GET /nodes/1.json
  def show
    listunspent(@node)
    if @address.present?
      z_listaddresses(@node)
    end
  end

  # GET /nodes/new
  def new
    @node = Node.new
  end

  # GET /nodes/1/edit
  def edit
  end

  # POST /nodes
  # POST /nodes.json
  def create
    @node = Node.new(node_params)

    respond_to do |format|
      if @node.save
        format.html {redirect_to @node, notice: 'Node was successfully created.'}
        format.json {render :show, status: :created, location: @node}
      else
        format.html {render :new}
        format.json {render json: @node.errors, status: :unprocessable_entity}
      end
    end
  end

  # PATCH/PUT /nodes/1
  # PATCH/PUT /nodes/1.json
  def update
    respond_to do |format|
      if @node.update(node_params)
        format.html {redirect_to @node, notice: 'Node was successfully updated.'}
        format.json {render :show, status: :ok, location: @node}
      else
        format.html {render :edit}
        format.json {render json: @node.errors, status: :unprocessable_entity}
      end
    end
  end

  # DELETE /nodes/1
  # DELETE /nodes/1.json
  def destroy
    @node.destroy
    respond_to do |format|
      format.html {redirect_to nodes_url, notice: 'Node was successfully destroyed.'}
      format.json {head :no_content}
    end
  end

  def set_t_address
    Node.all.each do |a|
      if listunspent(a) != nil
        listunspent = listunspent(a)
        p listunspent
        listunspent.keys.each do |b|
          if listunspent["#{b}"] > a.start_balance_t
            a.update(taddress: b)
          end
        end
      end
    end

    redirect_to nodes_url
  end

  def set_z_address
    Node.all.each do |a|
      z_listaddresses = z_listaddresses(a)
      if z_listaddresses != nil
        z_listaddresses.keys.each do |b|
          if z_listaddresses["#{b}"] > a.start_balance_z
            a.update(zaddress: b)
          end
        end
      end
    end

    redirect_to nodes_url
  end

  def z_gettotalbalance
    Node.all.each do |a|
      h = BitcoinRPC.new("http://#{a.node_username}:#{a.node_password}@#{a.ipv4}:8231")
      getinfo = h.z_gettotalbalance
      if getinfo.nil?
        Node.find_by_id(a.id).update({:balance_t => 101, :balance_z => 101})
      else
        Node.find_by_id(a.id).update({:balance_t => getinfo["transparent"], :balance_z => getinfo["private"]})
      end
    end
    redirect_to nodes_path
  end

  def return_amount
    @nodelist = AmountSend.need_to_return.map do |u|
      { :address => u.to, :amount => u.amount}
      u.update(status: 'success')
    end
    @command = "z_sendmany "  + "#{Setting.stk_node_address} " + "'#{@nodelist.to_json}'"
    redirect_to nodes_path
  end

  # def update_node_status(id)
  #   id.update(status: 'success')
  # end

  def listunspent(node)
    h = BitcoinRPC.new("http://#{node.node_username}:#{node.node_password}@#{node.ipv4}:8231")
    listunspent = h.listunspent
    address = Hash.new()
    if listunspent.nil?
      @address = nil
    else
      listunspent.each do |a|
        if address.keys.include?("a[\"address\"]")
          address[a["address"]] = a["amount"]
        else
          address[a["address"]] = address[a["address"]].to_f + a["amount"]
        end
      end
      @address = address
    end
  end

  def z_listaddresses(node)
    h = BitcoinRPC.new("http://#{node.node_username}:#{node.node_password}@#{node.ipv4}:8231")
    z_listaddresses = h.z_listaddresses
    address = Hash.new()
    if z_listaddresses.nil?
      @zaddress = nil
    else
      z_listaddresses.each do |a|
        address[a] = h.z_getbalance a
      end
      @zaddress = address
    end
  end

  def sync_node
    @params = {
        from: params[:sync_to_sheet][:from],
        to: params[:sync_to_sheet][:to]
    }
    p @params
    Node.sync_node(@params[:from], @params[:to])
    redirect_to nodes_path
  end

  private


  # Use callbacks to share common setup or constraints between actions.
  def set_node
    @node = Node.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def node_params
    params.require(:node).permit(:name, :domain, :ipv4, :ipv6, :node_username, :node_password, :taddress, :zaddress, :start_balance_t, :start_balance_z, :balance_t, :balance_z, :server_provider)
  end

end
